Main Page Widgets Namespaces Book

# Gtk::Main Class Reference

Inheritance diagram for Gtk::Main:

[legend]
List of all members.

## Detailed Description

Main application class Every application must have one of these objects.

It may not be global and must be the first Gtk object created. It is a singleton so declaring more than one will simply access the first created.

Normal use of this class is in the main() function to give argc and argv to the gtk initialization. Widgets can use Gtk::Main::quit() to exit from the application.

The internals of the widget have been disguised as signals so that the user can easily connect using the same methods used throughout the widget interface.

Minimal gtkmm application is something like this:

     int main(int argc, char *argv[]) {
         Gtk::Main kit(argc, argv);
         ... create some widgets ...
         kit.run();
     }

## Public Member Functions
| Main (int& argc, char**& argv, bool set_locale=true)
| See Main(int* argc, char*** argv, bool set_locale).
| Main (int* argc, char*** argv, bool set_locale=true)
| Scans the argument vector, and strips off all parameters known to GTK+.
| Main (int& argc, char**& argv, Glib::OptionContext& option_context)
| Scans the argument vector, and strips off all parameters parsed by GTK+ or your option_context.
virtual | ~Main ()
## Static Public Member Functions
static void | add_gtk_option_group (Glib::OptionContext& option_context, bool open_default_display=true)
| Add a Glib::OptionGroup, for the commandline arguments recognized by GTK+ and GDK, to a Glib::OptionContext, so that these commandline arguments will be processed in addition to the existing commandline arguments specified by the Glib::OptionContext.
static bool | events_pending ()
| Checks if any events are pending.
static void | init_gtkmm_internals ()
static Gtk::Main* | instance ()
| Access to the one global instance of Gtk::Main.
static bool | iteration (bool blocking=true)
| Runs a single iteration of the main loop.
static guint | level ()
static void | quit ()
| Makes the innermost invocation of the main loop return when it regains control.
static void | run (Window& window)
| Returns from the main loop when the window is closed.
static void | run ()
| Start the event loop.
static KeySnooperSig& | signal_key_snooper ()
| KeySnooper signal Allows you to channel keypresses to a signal handler without registering with the widget.
static QuitSig& | signal_quit ()
| Quit signal You can connect signal handlers to invoke actions when Gtk::Main::quit() has been called.
static RunSig& | signal_run ()
| Run signal.
## Protected Member Functions
virtual bool | events_pending_impl ()
void | init (int* argc, char*** argv, bool set_locale)
virtual bool | iteration_impl (bool blocking)
virtual guint | level_impl ()
| Main ()
virtual void | on_window_hide ()
virtual void | quit_impl ()
virtual void | run_impl ()
## Static Protected Attributes
static KeySnooperSig | signal_key_snooper_
static QuitSig | signal_quit_
static RunSig | signal_run_

## Constructor & Destructor Documentation

Gtk::Main::Main | ( | int& | argc,
|  | char **& | argv,
|  | Glib::OptionContext& | option_context
| ) |

  | Scans the argument vector, and strips off all parameters parsed by GTK+ or your option_context. Add a Glib::OptionGroup to the Glib::OptionContext to parse your own command-line arguments. Note: The argument strings themself won't be modified, although the pointers to them might change. This makes it possible to create your own argv of string literals, which have the type 'const char[]' in standard C++. (You might need to use const_cast<>, though.) This function automatically generates nicely formatted <option>--help</option> output. Note that your program will be terminated after writing out the help output. Parameters:
  | argc | a reference to the number of command line arguments.
  | argv | a reference to the array of command line arguments. a string which is displayed in the first line of <option>--help</option> output, after <literal><replaceable>programname</replaceable> [OPTION...]</literal>
  | option_context | A Glib::OptionContext containing Glib::OptionGroups which described the command-line arguments taken by your program.
  Exceptions:
  | Glib::OptionError |

Gtk::Main::Main | ( | int* | argc,
|  | char *** | argv,
|  | bool | set_locale = `true`
| ) |

| Scans the argument vector, and strips off all parameters known to GTK+. Your application may then handle the remaining arguments. Note: The argument strings themself won't be modified, although the pointers to them might change. This makes it possible to create your own argv of string literals, which have the type 'const char[]' in standard C++. (You might need to use const_cast<>, though.)

Gtk::Main::Main | ( | int& | argc,
|  | char **& | argv,
|  | bool | set_locale = `true`
| ) |

| See Main(int* argc, char*** argv, bool set_locale).

virtual Gtk::Main::~Main | ( |  | ) | `[virtual]`

Gtk::Main::Main | ( |  | ) | `[protected]`

## Member Function Documentation

static void Gtk::Main::add_gtk_option_group | ( | Glib::OptionContext& | option_context,
|  | bool | open_default_display = `true`
| ) | `[static]`

  | Add a Glib::OptionGroup, for the commandline arguments recognized by GTK+ and GDK, to a Glib::OptionContext, so that these commandline arguments will be processed in addition to the existing commandline arguments specified by the Glib::OptionContext. You do not need to use this method if you pass your Glib::OptionContext to the Main constructor, because it adds the gtk option group automatically. Parameters:
  | option_context | Option Context to which the group will be added.
  | open_default_display | Whether to open the default display when parsing the commandline arguments.

static bool Gtk::Main::events_pending | ( |  | ) | `[static]`

| Checks if any events are pending. This can be used to update the GUI and invoke timeouts etc. while doing some time intensive computation. Example: Updating the GUI during a long computation.
     // computation going on
     while( Gtk::Main::events_pending() )
       Gtk::Main::iteration();

     // computation continued
Returns: true if any events are pending, false otherwise.

virtual bool Gtk::Main::events_pending_impl | ( |  | ) | `[protected, virtual]`

void Gtk::Main::init | ( | int* | argc,
|  | char *** | argv,
|  | bool | set_locale
| ) | `[protected]`

static void Gtk::Main::init_gtkmm_internals | ( |  | ) | `[static]`

static Gtk::Main* Gtk::Main::instance | ( |  | ) | `[static]`

| Access to the one global instance of Gtk::Main.

static bool Gtk::Main::iteration | ( | bool | blocking = `true` | ) | `[static]`

  | Runs a single iteration of the main loop. If no events are waiting to be processed GTK+ will block until the next event is noticed. If you don't want to block then pass false for blocking or check if any events are pending with pending() first. Parameters:
  | blocking | Whether the caller must wait until the next event is noticed, or return immediately if there are no events.
Returns: true if quit() has been called for the innermost main loop.

virtual bool Gtk::Main::iteration_impl | ( | bool | blocking | ) | `[protected, virtual]`

static guint Gtk::Main::level | ( |  | ) | `[static]`

virtual guint Gtk::Main::level_impl | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Main::on_window_hide | ( |  | ) | `[protected, virtual]`

static void Gtk::Main::quit | ( |  | ) | `[static]`

| Makes the innermost invocation of the main loop return when it regains control.

virtual void Gtk::Main::quit_impl | ( |  | ) | `[protected, virtual]`

static void Gtk::Main::run | ( | Window& | window | ) | `[static]`

  | Returns from the main loop when the window is closed. When using this override, you should not use Gtk::Main::quit() to close the application, but just call hide() on your Window class. Parameters:
  | window | The window to show. This method will return when the window is hidden.

static void Gtk::Main::run | ( |  | ) | `[static]`

| Start the event loop. This begins the event loop which handles events. No events propagate until this has been called. It may be called recursively to popup dialogs

virtual void Gtk::Main::run_impl | ( |  | ) | `[protected, virtual]`

static KeySnooperSig& Gtk::Main::signal_key_snooper | ( |  | ) | `[static]`

| KeySnooper signal Allows you to channel keypresses to a signal handler without registering with the widget. Returns: KeySnooperSig A Signal to which you can connect a sigc::slot< int, Widget *, GdkEventKey * > It is the responsibility of the snooper to pass the keypress to the widget, however, care must be taken that the keypress is not passed twice.

static QuitSig& Gtk::Main::signal_quit | ( |  | ) | `[static]`

| Quit signal You can connect signal handlers to invoke actions when Gtk::Main::quit() has been called. Note that main loops can be nested by calling Gtk::Main::run() recursively, therefore receiving this signal doesn't necessarily mean the application is about to be terminated. If you want to receive a signal only when the last main loop quits, call connect() with `main_level = 1`.
     bool thisclass::mymethod() { return false; }
     Gtk::Main::signal_quit().connect(sigc::mem_fun(this, &thisclass::mymethod));
Returns: bool - `false` means callback is removed, `true` means it'll be called again the next the main loop quits.

static RunSig& Gtk::Main::signal_run | ( |  | ) | `[static]`

| Run signal. Returns: void

## Member Data Documentation

KeySnooperSig Gtk::Main::signal_key_snooper_`[static, protected]`

QuitSig Gtk::Main::signal_quit_`[static, protected]`

RunSig Gtk::Main::signal_run_`[static, protected]`

The documentation for this class was generated from the following file:

- main.h